diff --git a/src/doc/screen.1 b/src/doc/screen.1
index ff2fe82..8104198 100644
--- a/src/doc/screen.1
+++ b/src/doc/screen.1
@@ -4943,7 +4943,7 @@ Pablo Averbuj (pablo@averbuj.com).
 
 
 .SH VERSION
-This is version 4.0.2. Its roots are a merge of a custom version
+This is version 4.1.0. Its roots are a merge of a custom version
 2.3PR7 by Wayne Davison
 and several enhancements to Oliver Laumann's version 2.0. Note that all versions
 numbered 2.x are copyright by Oliver Laumann. 
@@ -4951,14 +4951,24 @@ numbered 2.x are copyright by Oliver Laumann.
 .SH AVAILABILITY
 The latest official release of 
 .I screen
-available via anonymous ftp from gnudist.gnu.org, nic.funet.fi or any other 
+available from http://ftp.gnu.org/software/screen/ or any other 
 .I GNU 
 distribution site. The home site of
 .I screen
-is ftp.uni-erlangen.de, in the directory
-pub/utilities/screen. The subdirectory `private' contains the latest beta
-testing release. If you want to help, send a note to
-screen@uni-erlangen.de.
+is http://www.gnu.org/software/screen/ .
+If you want to help, send a note to screen-devel@gnu.org.
+
+.I The Termcap Manual
+is written by Richard M. Stallman. It can be viewed and downloaded at
+http://www.gnu.org/software/termutils/manual/termcap-1.3/termcap.html .
+Soft cover print editions may be available from your local bookstore
+or library using the following information:
+.nf
+Title: The Termcap Manual
+Author: Richard M. Stallman
+Publisher: Free Software Foundation
+ISBN 10: 1-882114-13-2
+ISBN 13: 9781882114139
 
 .SH BUGS
 .PD
diff --git a/src/doc/screen.texinfo b/src/doc/screen.texinfo
index 539f23d..aa20c96 100644
--- a/src/doc/screen.texinfo
+++ b/src/doc/screen.texinfo
@@ -3158,8 +3158,8 @@ terminal does not support a visual bell, the visual bell message is
 displayed in the status line when the bell character is received. 
 Visual bell support of a terminal is 
 defined by the termcap variable @code{vb}. @xref{Bell, , Visual Bell, 
-termcap, The Termcap Manual}, for more information on visual bells. 
-The equivalent terminfo capability is @code{flash}.
+termcap, The Termcap Manual (@xref{Availability})}, for more information
+on visual bells. The equivalent terminfo capability is @code{flash}.
 
 Per  default, @code{vbell} is @samp{off}, thus the audible bell is used.
 @end deffn
@@ -4569,7 +4569,8 @@ If you would like to fully specify each window's termcap entry, you
 should instead set the @code{$SCREENCAP} variable prior to running
 @code{screen}.  @xref{Virtual Terminal}, for the details of the
 @code{screen} terminal emulation.  @xref{Top, , Termcap, termcap, The
-Termcap Manual}, for more information on termcap definitions.
+Termcap Manual (@xref{Availability})}, for more information on
+termcap definitions.
 
 @node Special Capabilities, Autonuke, Termcap Examples, Termcap
 @section Special Terminal Capabilities
@@ -5706,17 +5707,22 @@ Program for locking the terminal.
 @node Credits, Bugs, Files, Top
 @chapter Credits
 
-@noindent
-Authors @*
-=======
+@menu
+* Authors::               Authors of screen.
+* Contributors::          Everyone who has contributed.
+* Program Version::       What version of screen this manual describes.
+* Availability::          Where to find the latest screen version.
+@end menu
+
+@node Authors, Contributors,  , Credits
+@section Authors
 
 Originally created by Oliver Laumann, this latest version was
 produced by Juergen Weigert, Michael Schroeder, Micah Cowan and
 Sadrul Habib Chowdhury.
 
-@noindent
-Contributors @*
-============
+@node Contributors, Version, Authors, Credits
+@section Contributors
 
 @example
      Ken Beal (kbeal@@amber.ssd.csd.harris.com),
@@ -5749,16 +5755,38 @@ Contributors @*
      Pablo Averbuj (pablo@@averbuj.com).
 @end example
 
-@noindent
-Version @*
-=======
+@node Program Version, Availability, Contributors, Credits
+@section Version
 
 This manual describes version @value{version} of the @code{screen}
 program. Its roots are a merge of a custom version 2.3PR7 by Wayne
 Davison and several enhancements to Oliver Laumann's version 2.0.
 Note that all versions numbered 2.x are copyright by Oliver Laumann.
 
-See also @xref{Availability}.
+@node Availability,  , Program Version, Credits
+@section Availability
+@cindex availability
+
+@code{Screen} is available under the @code{GNU} copyleft.
+
+The latest official release of @code{screen} available 
+from @samp{http://ftp.gnu.org/software/screen/} or any 
+@code{GNU} distribution site.  The home site of
+@code{screen} is @samp{http://www.gnu.org/software/screen/}.
+If you want to help, send a note to screen-devel@@gnu.org.
+
+@var{The Termcap Manual} is written by Richard M. Stallman. It can 
+be viewed and downloaded at 
+@code{http://www.gnu.org/software/termutils/manual/termcap-1.3/termcap.html}.
+Soft cover print editions may be available from your local bookstore
+or library using the following information:
+@example
+Title: The Termcap Manual
+Author: Richard M. Stallman
+Publisher: Free Software Foundation
+ISBN 10: 1-882114-13-2
+ISBN 13: 9781882114139
+@end example
 
 @node Bugs, Installation, Credits, Top
 @chapter Bugs
@@ -5771,7 +5799,6 @@ found a bug not mentioned here.
 @menu
 * Known Bugs::                  Problems we know about.
 * Reporting Bugs::              How to contact the maintainers.
-* Availability::                Where to find the latest screen version.
 @end menu
 
 @node Known Bugs, Reporting Bugs,  , Bugs
@@ -5839,7 +5866,7 @@ A weird imagination is most useful to gain full advantage of all the
 features.
 @end itemize
 
-@node Reporting Bugs, Availability, Known Bugs, Bugs
+@node Reporting Bugs, , Known Bugs, Bugs
 @section Reporting Bugs
 @cindex bug report
 
@@ -5854,20 +5881,6 @@ enabled, reproduce the bug, and have a look at the debug output written to
 the directory @file{/tmp/debug}. If necessary quote suspect passages from the
 debug output and show the contents of your @file{config.h} if it matters.
 
-@node Availability,  , Reporting Bugs, Bugs
-@section Availability
-@cindex availability
-
-@code{Screen} is available under the @code{GNU} copyleft.
-
-The latest official release of @code{screen} available via anonymous
-ftp from @samp{prep.ai.mit.edu}, @samp{nic.funet.fi} or any other
-@code{GNU} distribution site.  The home site of 
-@code{screen} is @samp{ftp.uni-erlangen.de
-(131.188.3.71)}, in the directory @file{pub/utilities/screen}.
-The subdirectory @samp{private} contains the latest beta testing release.
-If you want to help, send a note to screen@@uni-erlangen.de.
-
 @node Installation, Concept Index, Bugs, Top
 @chapter Installation
 @cindex installation